
var isRequestPermission = false;
var GameSelectLayer = cc.Layer.extend({
    sprite_book: null,
    book_listener: null,
    ad_view: null,
    layer_quit: null,

    ctor: function () {
        //////////////////////////////
        // 1. super init first
        this._super();

        /////////////////////////////
        // 2. add a menu item with "X" image, which is clicked to quit the program
        //    you may modify it.
        // ask the window size
        var size = cc.winSize;

        var self = this;
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function (keyCode, event) {
                if (keyCode == cc.KEY.back) {

                    if(IS_WALL_SHOW){
                        dismissAppWallLayer();
                        return;
                    }
                    if (self.lock_ad) {
                        self.lock_ad.removeFromParent(true);
                        self.lock_ad = null;
                        return;
                    }
                    if (self.layer_quit) {
                        self.layer_quit.removeFromParent(true);
                        self.layer_quit = null;
                    } else {
                        var ad_item = getQuitAd();
                        if (ad_item) {
                            self.layer_quit = new QuitAdViewLayer(function (action) {
                                switch (action) {
                                    case "quit": {
                                        ddStopAllEffect();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue": {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            }, ad_item);
                        } else {
                            self.layer_quit = new QuitViewLayer(function (action) {
                                switch (action) {
                                    case "quit": {
                                        ddStopAllEffect();
                                        quiteGame();
                                        break;
                                    }
                                    case "continue": {
                                        self.layer_quit.removeFromParent(true);
                                        self.layer_quit = null;
                                        break;
                                    }
                                    default:
                                        break;
                                }
                            });
                        }
                        self.addChild(self.layer_quit, 250);
                    }
                }
            }
        }, this);

        var background = new cc.Sprite("res/game_select/background.jpg");
        background.x = size.width / 2;
        background.y = size.height / 2;
        resetScale(background);
        this.addChild(background, 0);

        this.arry_menu_item = [];


        var stage1_menu_item = new cc.MenuItemImage(
            "res/game_select/menu_stage1.png",
            "res/game_select/menu_stage1.png",
            function () {
                cc.director.pushScene(cc.TransitionPageTurn(1, new Stage1Scene(), false));
            }, this);
        stage1_menu_item.attr({
            x: size.width / 3 + 30,
            y: size.height * 2 / 3.0 + 40,
            anchorX: 0.5,
            anchorY: 0.5,
            scale: 1
        });
        this.arry_menu_item[0] = stage1_menu_item;

        var stage2_menu_item = new cc.MenuItemImage(
            "res/game_select/menu_stage2.png",
            "res/game_select/menu_stage2.png",
            function () {
                cc.director.pushScene(cc.TransitionPageTurn(1, new Stage2Scene(), false));
            }, this);
        stage2_menu_item.attr({
            x: size.width * 2 / 3.0 + 50,
            y: size.height * 2 / 3.0 + 40,
            anchorX: 0.5,
            anchorY: 0.5,
            scale: 1
        });
        this.arry_menu_item[1] = stage2_menu_item;

        var stage3_menu_item = new cc.MenuItemImage(
            "res/game_select/menu_stage3.png",
            "res/game_select/menu_stage3.png",
            function () {
                if(shouldShowLock()){
                    self.lock_ad=showLockAd(self)
                }else{
                    cc.director.pushScene(cc.TransitionPageTurn(1, new Stage3Scene(), false));
                }
            }, this);
        stage3_menu_item.attr({
            x: size.width / 3 + 30,
            y: size.height / 3.0 - 40,
            anchorX: 0.5,
            anchorY: 0.5,
            scale: 1
        });
        this.arry_menu_item[2] = stage3_menu_item;

        var stage4_menu_item = new cc.MenuItemImage(
            "res/game_select/menu_tv.png",
            "res/game_select/menu_tv.png",
            function () {
                if(shouldShowLock()){
                    self.lock_ad=showLockAd(self)
                }else{
                    ddStopAllEffect();
                    playVideo();
                }

            }, this);
        stage4_menu_item.attr({
            x: size.width * 2 / 3.0 + 50,
            y: size.height / 3.0 - 40,
            anchorX: 0.5,
            anchorY: 0.5,
            scale: 1
        });
        this.arry_menu_item[3] = stage4_menu_item;

        var menu = new cc.Menu(this.arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 1);

        this.getAdList(function () {
            if (AD_ENABLE) {
                this.ad_view = new AdViewLayer(ARRY_AD_HOME, cc.size(isFullScreenDevice()?220:140, cc.winSize.height));
                this.addChild(this.ad_view, 350);
            }
            if (shouldShowLock()) {

                var lock1 = new cc.Sprite("res/adView/lock/lock");
                lock1.setPosition(this.arry_menu_item[2].getPosition());
                lock1.setScale(0.8);
                this.addChild(lock1, 200);

                var lock2 = new cc.Sprite("res/adView/lock/lock");
                lock2.setPosition(this.arry_menu_item[3].getPosition());
                lock2.setScale(0.8);
                this.addChild(lock2, 200);

            }

        }.bind(this));
         addPrivacyPolicyButton(this,"res/RetBtnNormal.png");
         if(!isRequestPermission){
                   requestPermission();
                   isRequestPermission = true;
                }

        return true;
    },
    getAdList: function (showAd) {
        if (!recommandEnable()) {
            AD_ENABLE = false;
            return;
        }


        getAdConfig("http://bb.shoujiduoduo.com/baby/game.php?act=sharelist&rid=10002&ver="+ getVersionCode()  + "&isar=" + (cc.sys.os == cc.sys.OS_ANDROID ? 1 : 0), function () {
            var ad_value = cc.sys.localStorage.getItem("KEY_AD_LIST");
            if (ad_value) {
                var parse_result = JSON.parse(ad_value);
                AD_ENABLE = parse_result.enable;
                var ad_list = parse_result.list;
                var ad_in_list = parse_result.inads;
                var ad_quit_list = parse_result.quitads;
                var ad_lock_list = parse_result.lockads;
                if (null != ad_list) {
                    var AD_HOME_LIST = new Array(ad_list.length);
                    parseAdList(AD_HOME_LIST, ad_list);
                    ARRY_AD_HOME = filterAdInstall(AD_HOME_LIST, 8);
                    ARRY_AD_WALL = filterAndSortAdList(AD_HOME_LIST,ARRY_AD_HOME);

                }

                if (null != ad_in_list) {
                    var AD_IN_LIST = new Array(ad_in_list.length);
                    parseAdList(AD_IN_LIST, ad_in_list);
                    ARRY_AD_IN = filterAdInstall(AD_IN_LIST, 4);
                }

                if (null != ad_quit_list) {
                    var AD_QUIT_LIST = new Array(ad_quit_list.length);
                    parseAdList(AD_QUIT_LIST, ad_quit_list);
                    ARRY_AD_QUIT = filterAdInstall(AD_QUIT_LIST, 4);
                }
                if (null != ad_lock_list) {
                    var AD_LOCK_LIST = new Array();
                    parseAdList(AD_LOCK_LIST, ad_lock_list);
                    ARRY_AD_LOCK = lockAdNotInstall(AD_LOCK_LIST, 4);
                }


                showAd();
            }
        });
    }
});

var GameSelectScene = cc.Scene.extend({
    ctor: function () {
        this._super();
        var layer = new GameSelectLayer();
        this.addChild(layer);

        showAdBanner(true,0.3,0);
    },
    onEnter: function () {
        this._super();
    }
});

