var ColorSprite = cc.Sprite.extend({
    name_color:null,
    ctor:function(filename, color_name){
        this._super(filename);
		this.name_color = color_name;
    },
    setColorName:function(color_name){
        this.name_color = color_name;
    },
    getColorName:function(){
        return this.name_color;
    }
});


var Stage1Layer = cc.Layer.extend({
    sprite_goal:null,
    menu_retry:null,
    volumeOn:null,
                                      
    arry_color_name:null,
    arry_color_order:null,
    n_cur_index:null,
    n_cur_goal_num:null,
                                      
    sprite_color_1:null,
    sprite_color_2:null,
    sprite_color_3:null,
    sprite_color_4:null,
    sprite_color_5:null,
    sprite_color_6:null,
    sprite_color_7:null,
    sprite_color_8:null,
    
    star_ad:null,
    
    sprite_select:null,
                                  
    sprite_emission_animation:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();

		cc.eventManager.addListener({
        	event: cc.EventListener.KEYBOARD,
        	onKeyReleased: function(keyCode, event) {
       			if (keyCode == cc.KEY.back) {
        			ddStopAllEffect();
        			cc.director.popScene();
        		}
        }}, this);
        // ask the window size
        var size = cc.winSize;
        this.volumeOn = (0.0 != cc.audioEngine.getEffectsVolume());
        this.n_cur_index = 0;
        this.n_cur_goal_num = 0;

        var sprite_background = new cc.Sprite("res/stage1/background1.jpg");
        sprite_background.x = size.width / 2;
        sprite_background.y = size.height / 2;
        resetScale(sprite_background);
        this.addChild(sprite_background, 0);
                                      
        this.arry_color_name = ["Red", "Blue", "Yellow", "Orange", "Green", "Purple"];
                                      
        this.sprite_color_1 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 1) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 1) % 6]);
        this.sprite_color_1.x = size.width / 2.0 - 50;
        this.sprite_color_1.y = size.height / 2.0 + 50;
        this.sprite_color_1.setVisible(false);
        this.addChild(this.sprite_color_1, 2);
        cc.log("sprite color 1 name is " + this.sprite_color_1.getColorName());
                                      
        this.sprite_color_2 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 2) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 2) % 6]);
        this.sprite_color_2.x = size.width / 2.0 + 100 + gapX() / 3;
        this.sprite_color_2.y = size.height / 2.0 + 50;
        this.sprite_color_2.setVisible(false);
        this.addChild(this.sprite_color_2, 3);
        cc.log("sprite color 2 name is " + this.sprite_color_2.getColorName());
                                      
        this.sprite_color_3 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 3) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 3) % 6]);
        this.sprite_color_3.x = size.width / 2.0 + 250 + gapX() * 2 / 3;
        this.sprite_color_3.y = size.height / 2.0 + 50;
        this.sprite_color_3.setVisible(false);
        this.addChild(this.sprite_color_3, 4);
        cc.log("sprite color 3 name is " + this.sprite_color_3.getColorName());
                                      
        this.sprite_color_4 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 4) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 4) % 6]);
        this.sprite_color_4.x = size.width / 2.0 + 400  + gapX() * 3 / 3;
        this.sprite_color_4.y = size.height / 2.0 + 50;
        this.sprite_color_4.setVisible(false);
        this.addChild(this.sprite_color_4, 5);
        cc.log("sprite color 4 name is " + this.sprite_color_4.getColorName());
                                      
        this.sprite_color_5 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 5) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 5) % 6]);
        this.sprite_color_5.x = size.width / 2.0 - 50;
        this.sprite_color_5.y = size.height / 2.0 - 130;
        this.sprite_color_5.setVisible(false);
        this.addChild(this.sprite_color_5, 6);
        cc.log("sprite color 5 name is " + this.sprite_color_5.getColorName());
                                      
        this.sprite_color_6 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 6) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 6) % 6]);
        this.sprite_color_6.x = size.width / 2.0 + 100 + gapX() / 3;
        this.sprite_color_6.y = size.height / 2.0 - 130;
        this.sprite_color_6.setVisible(false);
        this.addChild(this.sprite_color_6, 7);
        cc.log("sprite color 6 name is " + this.sprite_color_6.getColorName());
                            
        this.sprite_color_7 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 7) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 7) % 6]);
        this.sprite_color_7.x = size.width / 2.0 + 250 + gapX() * 2 / 3;
        this.sprite_color_7.y = size.height / 2.0 - 130;
        this.sprite_color_7.setVisible(false);
        this.addChild(this.sprite_color_7, 8);
        cc.log("sprite color 3 name is " + this.sprite_color_3.getColorName());
                                      
        this.sprite_color_8 = new ColorSprite("res/stage1/" + this.arry_color_name[(this.n_cur_index + 8) % 6] + "1.png", this.arry_color_name[(this.n_cur_index + 8) % 6]);
        this.sprite_color_8.x = size.width / 2.0 + 400 + gapX() * 3 / 3;
        this.sprite_color_8.y = size.height / 2.0 - 130;
        this.sprite_color_8.setVisible(false);
        this.addChild(this.sprite_color_8, 9);
        cc.log("sprite color 8 name is " + this.sprite_color_8.getColorName());
                                  
        this.sprite_emission_animation = new cc.Sprite("res/Emission/Emission1.png");
        this.sprite_emission_animation.x = 200;
        this.sprite_emission_animation.y = size.height / 2.0 + 90;
        this.sprite_emission_animation.setVisible(false);
        this.addChild(this.sprite_emission_animation, 10);
                                      
        this.sprite_goal = new ColorSprite("res/stage1/Goal_" + this.arry_color_name[(this.n_cur_index) % 6] + ".png", this.arry_color_name[(this.n_cur_index) % 6]);
        this.sprite_goal.x = 200;
        this.sprite_goal.y = size.height / 2.0;
        this.addChild(this.sprite_goal, 1);
                                      
        var arry_menu_item = [];
        var closeItem = new cc.MenuItemImage(
            "res/RetBtnNormal.png",
            "res/ReturnBtnHigh.png",
            function () {
                this.removeAllChildren();
                ddStopAllEffect();
                cc.director.popToRootScene();
            }, this);
        closeItem.attr({
            x: isFullScreenDevice()?170:70,
            y: size.height - 70,
            anchorX: 0.5,
            anchorY: 0.5,
            scale:0.8
        });
        arry_menu_item[0] = closeItem;
                                    
        this.menu_retry = new cc.MenuItemImage(
            "res/RetryBtnNormal.png",
            "res/RetryBtnHigh.png",
            function(){
                cc.log("replay menu is clicked!");
                this.reshuffleGame(true);
        }, this);
        this.menu_retry.setVisible(false);
        this.menu_retry.attr({
                x: size.width * 2.0 / 3,
                y: size.height / 2,
                anchorX: 0.5,
                anchorY: 0.5
        });
        arry_menu_item[1] = this.menu_retry;
                                      
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 11);
                                      
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                                                                                    
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                self.sprite_select = null;                                                                    
                if (cc.rectContainsPoint(rect, locationInNode)) {
                	self.sprite_select = target;
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
            	if (!self.sprite_select) {
					return;
				}
                var delta = touch.getDelta();
                self.sprite_select.x += delta.x;
                self.sprite_select.y += delta.y;
            },
            onTouchEnded: function (touch, event) {
                if(!self.sprite_select){
                	return;
                }
                var move_interval = Math.abs((self.sprite_select.x - 200) / 1200);
                console.log(move_interval);
                var end_position = cc.p(200, cc.winSize.height / 2 + 50);
                if (self.sprite_select == self.sprite_color_1) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                       // cc.audioEngine.playEffect("res/sound/great.mp3", false);
                		self.sprite_select.runAction(cc.sequence(
                				cc.moveTo(move_interval, end_position),
                				cc.callFunc(function() {
                					ddPlayEffect('',"res/sound/great.mp3", false);
                					if(0 == --self.n_cur_goal_num){
                						cc.eventManager.setEnabled(false);
                						self.hideAllSprite();

//              						self.reshuffleGame();
                					}else{
                						self.showEmissionAnimation();
                						self.sprite_color_1.runAction(cc.FadeTo(0.5, 0));
                					}
								}.bind(self))
                		));
                        
                                                                                    
                    }else{
                        self.sprite_color_1.x = size.width / 2.0 - 50;
                        self.sprite_color_1.y = size.height / 2.0 + 50;
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                    }
                } else if (self.sprite_select == self.sprite_color_2) {
                    
                    if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                        
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_2.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        self.sprite_color_2.x = size.width / 2.0 + 100+ gapX() / 3;
                        self.sprite_color_2.y = size.height / 2.0 + 50;
                    }
                }else if (self.sprite_select == self.sprite_color_3) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_3.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        self.sprite_color_3.x = size.width / 2.0 + 250+ gapX() * 2 / 3;
                        self.sprite_color_3.y = size.height / 2.0 + 50;
                    }
                }else if (self.sprite_select == self.sprite_color_4) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_4.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        self.sprite_color_4.x = size.width / 2.0 + 400+ gapX() * 3 / 3;
                        self.sprite_color_4.y = size.height / 2.0 + 50;
                    }
                }else if (self.sprite_select == self.sprite_color_5) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_5.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        self.sprite_color_5.x = size.width / 2.0 - 50;
                        self.sprite_color_5.y = size.height / 2.0 - 130;
                    }
                }else if (self.sprite_select == self.sprite_color_6) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_6.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        self.sprite_color_6.x = size.width / 2.0 + 100+ gapX() / 3;
                        self.sprite_color_6.y = size.height / 2.0 - 130;
                    }
                }else if (self.sprite_select == self.sprite_color_7) {
                	if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_7.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        self.sprite_color_7.x = size.width / 2.0 + 250+ gapX() * 2 / 3;
                        self.sprite_color_7.y = size.height / 2.0 - 130;
                    }
                }else if (self.sprite_select == self.sprite_color_8) {
                    if(self.sprite_goal.getColorName() == self.sprite_select.getColorName()){
                    	self.sprite_select.runAction(cc.sequence(
                    			cc.moveTo(move_interval, end_position),
                    			cc.callFunc(function() {
                    				ddPlayEffect('',"res/sound/great.mp3", false);
                    				if(0 == --self.n_cur_goal_num){
                    					cc.eventManager.setEnabled(false);
                    					self.hideAllSprite();

//                  					self.reshuffleGame();
                    				}else{
                    					self.showEmissionAnimation();
                    					self.sprite_color_8.runAction(cc.FadeTo(0.5, 0));
                    				}
                    			}.bind(self))
                    	));
                    }else{
                        ddPlayEffect('',"res/sound/fail.mp3", false);
                        //cc.audioEngine.playEffect("res/sound/fail.mp3", false);
                        self.sprite_color_8.x = size.width / 2.0 + 400+ gapX() * 3 / 3;
                        self.sprite_color_8.y = size.height / 2.0 - 130;
                    }
                }
        }});
                                      
        cc.eventManager.addListener(sprite_listener, this.sprite_color_1);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_2);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_3);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_4);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_5);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_6);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_7);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_8);
        
        this.showStarAd();
                                  
        this.scheduleOnce(function reshuffle_game(){
            this.reshuffleGame(true);
        } ,1.0);
                                      
        return true;
    },
    showStarAd:function(){
    	showStarAd(this, this.star_ad, cc.p(60, -20));
    },
    reshuffleGame:function(restart){
        if(restart){
            this.n_cur_index = 0;
            this.menu_retry.setVisible(false);
        }else {
            this.n_cur_index = ++this.n_cur_index % 6;
        }
        var size = cc.winSize;
        this.sprite_color_1.x = size.width / 2.0 - 50;
        this.sprite_color_1.y = size.height / 2.0 + 50;
        this.sprite_color_2.x = size.width / 2.0 + 100+ gapX() / 3;
        this.sprite_color_2.y = size.height / 2.0 + 50;
        this.sprite_color_3.x = size.width / 2.0 + 250+ gapX() * 2 / 3;
        this.sprite_color_3.y = size.height / 2.0 + 50;
        this.sprite_color_4.x = size.width / 2.0 + 400+ gapX();
        this.sprite_color_4.y = size.height / 2.0 + 50;
        this.sprite_color_5.x = size.width / 2.0 - 50;
        this.sprite_color_5.y = size.height / 2.0 - 130;
        this.sprite_color_6.x = size.width / 2.0 + 100+ gapX() / 3;
        this.sprite_color_6.y = size.height / 2.0 - 130;
        this.sprite_color_7.x = size.width / 2.0 + 250+ gapX() * 2 / 3;
        this.sprite_color_7.y = size.height / 2.0 - 130;
        this.sprite_color_8.x = size.width / 2.0 + 400+ gapX();
        this.sprite_color_8.y = size.height / 2.0 - 130;
                                      
        cc.eventManager.setEnabled(true);
                                      
        var arry_color_source = [((this.n_cur_index + 1) * 2) % 12, ((this.n_cur_index + 1) * 2 + 1) % 12, ((this.n_cur_index + 2) * 2) % 12, ((this.n_cur_index + 2) * 2 + 1) % 12, ((this.n_cur_index + 3) * 2) % 12, ((this.n_cur_index + 3) * 2 + 1) % 12, ((this.n_cur_index + 4) * 2) % 12, ((this.n_cur_index + 4) * 2 + 1) % 12, ((this.n_cur_index + 5) * 2) % 12, ((this.n_cur_index + 5) * 2 + 1) % 12];
        this.reShuffleArray(arry_color_source);
                                      
        this.n_cur_goal_num = Math.floor(Math.random() * 10) % 2 + 1;
        cc.log("current goal number is ", this.n_cur_goal_num);
        cc.log("current index number is ", this.n_cur_index);
        var n_random = Math.floor(Math.random() * 10);
        switch(this.n_cur_goal_num){
            case 1:{
                this.arry_color_order = [(this.n_cur_index * 2) % 12, arry_color_source[0], arry_color_source[1], arry_color_source[2], arry_color_source[3], arry_color_source[4], arry_color_source[5], arry_color_source[6]];
                break;
            }
            case 2:{
                this.arry_color_order = [(this.n_cur_index * 2) % 12, (this.n_cur_index * 2 + 1) % 12, arry_color_source[0], arry_color_source[1], arry_color_source[2], arry_color_source[3], arry_color_source[4], arry_color_source[5]];
                break;
            }
            default:
            {
                break;
            }
        }
        this.reShuffleArray(this.arry_color_order);
                                      
        for(var index = 0; index < 8; ++index)
        {
            cc.log("cur index is " + this.arry_color_order[index]  / 2 + "   " + Math.floor(this.arry_color_order[index]  / 2));
        }
                                      
        this.sprite_goal.setTexture("res/stage1/Goal_" + this.arry_color_name[(this.n_cur_index) % 6] + ".png");
        this.sprite_goal.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        ddPlayEffect('',"res/sound/" + this.arry_color_name[(this.n_cur_index) % 6] + ".mp3");
        //cc.audioEngine.playEffect("res/sound/" + this.arry_color_name[(this.n_cur_index) % 6] + ".mp3");
                                      
        if(Math.floor(this.arry_color_order[0] / 2) == this.n_cur_index){
            this.sprite_color_1.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[0] % 2) + ".png");
            this.sprite_color_1.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_1.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[0] / 2)] + (this.arry_color_order[0] % 2) + ".png");
            this.sprite_color_1.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[0] / 2)]);
        }
        if(Math.floor(this.arry_color_order[1] / 2) == this.n_cur_index){
            this.sprite_color_2.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[1] % 2) + ".png");
            this.sprite_color_2.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_2.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[1] / 2)] + (this.arry_color_order[1] % 2) + ".png");
            this.sprite_color_2.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[1] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[2] / 2) == this.n_cur_index){
            this.sprite_color_3.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[2] % 2) + ".png");
            this.sprite_color_3.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_3.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[2] / 2)] + (this.arry_color_order[2] % 2) + ".png");
            this.sprite_color_3.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[2] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[3] / 2) == this.n_cur_index){
            this.sprite_color_4.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[3] % 2) + ".png");
            this.sprite_color_4.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_4.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[3] / 2)] + (this.arry_color_order[3] % 2) + ".png");
            this.sprite_color_4.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[3] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[4] / 2) == this.n_cur_index){
            this.sprite_color_5.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[4] % 2) + ".png");
            this.sprite_color_5.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_5.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[4] / 2)] + (this.arry_color_order[4] % 2) + ".png");
            this.sprite_color_5.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[4] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[5] / 2) == this.n_cur_index){
            this.sprite_color_6.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[5] % 2) + ".png");
            this.sprite_color_6.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_6.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[5] / 2)] + (this.arry_color_order[5] % 2) + ".png");
            this.sprite_color_6.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[5] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[6] / 2) == this.n_cur_index){
            this.sprite_color_7.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[6] % 2) + ".png");
            this.sprite_color_7.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_7.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[6] / 2)] + (this.arry_color_order[6] % 2) + ".png");
            this.sprite_color_7.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[6] / 2)]);
        }
                                      
        if(Math.floor(this.arry_color_order[7] / 2) == this.n_cur_index){
            this.sprite_color_8.setTexture("res/stage1/" + this.arry_color_name[(this.n_cur_index) % 6] + (this.arry_color_order[7] % 2) + ".png");
            this.sprite_color_8.setColorName(this.arry_color_name[(this.n_cur_index) % 6]);
        }else{
            this.sprite_color_8.setTexture("res/stage1/" + this.arry_color_name[Math.floor(this.arry_color_order[7] / 2)] + (this.arry_color_order[7] % 2) + ".png");
            this.sprite_color_8.setColorName(this.arry_color_name[Math.floor(this.arry_color_order[7] / 2)]);
        }

//        cc.audioEngine.playEffect("res/sound/"+this.arry_shape_goal_name[this.n_cur_index]+".mp3", false);
        this.sprite_color_1.setVisible(true);
        this.sprite_color_2.setVisible(true);
        this.sprite_color_3.setVisible(true);
        this.sprite_color_4.setVisible(true);
        this.sprite_color_5.setVisible(true);
        this.sprite_color_6.setVisible(true);
        this.sprite_color_7.setVisible(true);
        this.sprite_color_8.setVisible(true);
                                    
        this.sprite_color_1.runAction(cc.FadeTo(1, 255));
        this.sprite_color_2.runAction(cc.FadeTo(1, 255));
        this.sprite_color_3.runAction(cc.FadeTo(1, 255));
        this.sprite_color_4.runAction(cc.FadeTo(1, 255));
        this.sprite_color_5.runAction(cc.FadeTo(1, 255));
        this.sprite_color_6.runAction(cc.FadeTo(1, 255));
        this.sprite_color_7.runAction(cc.FadeTo(1, 255));
        this.sprite_color_8.runAction(cc.FadeTo(1, 255));
                                      
//        this.sprite_color_8.setColor(cc.color({r: 255, g: 0, b: 0, a: 255}));
        
        this.sprite_goal.runAction(cc.sequence(
            cc.FadeTo(1, 255),
            cc.scaleTo(0.4, 0.9, 0.9),
            cc.scaleTo(0.4, 1.1, 1.1),
            cc.scaleTo(0.2, 1.0, 1.0)
        ));
    },
    reShuffleArray:function (array) {
        var length = array.length;
        for (var i = 0; i < length; i++) {
        var sidx = Math.floor((Math.random()) * (length-1));
            if (sidx != i) {
                var tmp = array[i];
                array[i] = array[sidx];
                array[sidx] = tmp;
            }
        }
    },
    hideAllSprite:function(){
                                  this.showEmissionAnimation();
                                  
        this.sprite_color_1.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_2.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_3.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_4.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_5.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_6.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_7.runAction(cc.FadeTo(0.5, 0));
        this.sprite_color_8.runAction(cc.FadeTo(0.5, 0));
                                      
        this.sprite_goal.runAction(cc.Sequence.create(cc.FadeTo(1, 0), cc.CallFunc.create(function(){
            if(5 == this.n_cur_index){
                ddPlayEffect('',"res/sound/success.mp3", false);
                //cc.audioEngine.playEffect("res/sound/success.mp3", false);
                this.sprite_color_1.setVisible(false);
                this.sprite_color_2.setVisible(false);
                this.sprite_color_3.setVisible(false);
                this.sprite_color_4.setVisible(false);
                this.sprite_color_5.setVisible(false);
                this.sprite_color_6.setVisible(false);
                this.sprite_color_7.setVisible(false);
                this.sprite_color_8.setVisible(false);
                this.menu_retry.setVisible(true);
                cc.eventManager.setEnabled(true);
            }else {
                this.reshuffleGame();
            }
        }.bind(this))));
    },
    showEmissionAnimation:function(){
        this.sprite_emission_animation.stopAllActions();
        this.sprite_emission_animation.setVisible(true);
                        
        var animation_emission = new cc.Animation();
        animation_emission.setDelayPerUnit(0.1);
        animation_emission.setRestoreOriginalFrame(false);
        for(var n_index = 1; n_index < 22; ++n_index){
            animation_emission.addSpriteFrameWithFile("res/Emission/Emission"+n_index+".png");
        }
                                  
        this.sprite_emission_animation.runAction(cc.Sequence.create(cc.Animate.create(animation_emission), cc.CallFunc.create(function(){
            this.sprite_emission_animation.stopAllActions();
            this.sprite_emission_animation.setVisible(false);
        }.bind(this))));
    }
});

var Stage1Scene = cc.Scene.extend({
    ctor:function(){
        this._super();
        var layer = new Stage1Layer();
        this.addChild(layer);
    },
    onEnter:function () {
        this._super();
        
    }
});

