var ColorSprite = cc.Sprite.extend({
    name_color:null,
    ctor:function(filename, color_name){
        this._super(filename);
        this.name_color = color_name;
    },
    setColorName:function(color_name){
        this.name_color = color_name;
    },
    getColorName:function(){
        return this.name_color;
    }
});


var Stage2Layer = cc.Layer.extend({
    volumeOn:null,
                                      
    arry_color_name:null,
    n_color_select:null,
                                      
    sprite_color_1:null,
    sprite_color_2:null,
    sprite_color_3:null,
    sprite_color_4:null,
    sprite_color_5:null,
    sprite_color_6:null,
    sprite_color_7:null,
    sprite_color_8:null,
                                  
    polygon_banana:null,
    polygon_pear:null,
    polygon_apple:null,
    polygon_limon:null,
    polygon_orange:null,
    polygon_grapes:null,
    polygon_pseudocerasus:null,
    polygon_strawberry:null,
    
    star_ad:null,
                                  
    arry_pen:null,
    
    ctor:function () {
        //////////////////////////////
        // 1. super init first
        this._super();

		cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
               	if (keyCode == cc.KEY.back) {
          			ddStopAllEffect();
                	cc.director.popScene();
           		}
        }}, this);
        // ask the window size
        var size = cc.winSize;
        this.volumeOn = (0.0 != cc.audioEngine.getEffectsVolume());
        this.n_color_select = -1;
        this.polygon_banana = [[0, 157], [0, 107], [68, 0], [170, 0],
                               [237, 59], [237, 113], [208, 167], [180, 167],
                               [174, 144], [128, 109], [88, 111], [18, 159]];
        this.polygon_pear = [[13, 206], [40, 162], [26, 65], [21, 103],
                               [0, 72], [0, 32], [33, 0], [86, 0],
                               [116, 52], [84, 123], [116, 210]];
        this.polygon_apple = [[0, 94], [34, 0], [108, 0], [164, 48],
                                [164, 94], [111, 132], [126, 152], [124, 164],
                                [44, 152], [0, 98]];
        this.polygon_orange = [[68, 103], [12, 83], [0, 50], [0, 74],
                                [28, 0], [64, 0], [98, 33], [90, 75],
                                [118, 83], [90, 91]];
        this.polygon_limon = [[36, 87], [0, 55], [0, 68], [24, 0],
                                [56, 0], [87, 24], [93, 78], [58, 87]];
        this.polygon_pseudocerasus = [[31, 122], [23, 107], [32, 77], [0, 47],
                                [0, 15], [23, 0], [93, 0], [108, 23],
                                [106, 47], [67, 91], [85, 110], [84, 121]];
        this.polygon_grapes = [[0, 60], [0, 36], [18, 18], [122, 0],
                                [144, 0], [184, 62], [212, 48], [237, 48],
                                [218, 96], [164, 154], [112, 141], [80, 152]];
        this.polygon_strawberry = [[76, 137], [12, 28], [0, 34], [16, 18],
                                [52, 27], [74, 0], [116, 0], [163, 40],
                                [155, 59], [175, 74], [154, 110], [106, 111]];

        var sprite_background = new cc.Sprite("res/stage2/background2.jpg");
        sprite_background.x = size.width / 2;
        sprite_background.y = size.height / 2;
        resetScale(sprite_background);
        this.addChild(sprite_background, 0);
                                  
        var sprite_paper = new cc.Sprite("res/stage2/whitepaper.png");
        sprite_paper.x = size.width / 2;
        sprite_paper.y = size.height / 2;
        this.addChild(sprite_paper, 1);
                                  
        var sprite_plate = new cc.Sprite("res/stage2/plate.png");
        sprite_plate.x = size.width / 2;
        sprite_plate.y = size.height / 2 - 80;
        this.addChild(sprite_plate, 2);
                                  
        this.sprite_color_1 = new cc.Sprite("res/stage2/pear.png");
        this.sprite_color_1.x = size.width / 2 - 50;
        this.sprite_color_1.y = size.height / 2 + 80;
        this.addChild(this.sprite_color_1, 3);
                                  
        this.sprite_color_2 = new cc.Sprite("res/stage2/apple.png");
        this.sprite_color_2.x = size.width / 2 + 70;
        this.sprite_color_2.y = size.height / 2 + 60;
        this.addChild(this.sprite_color_2, 4);
                                  
        this.sprite_color_3 = new cc.Sprite("res/stage2/grapes.png");
        this.sprite_color_3.x = size.width / 2 - 100;
        this.sprite_color_3.y = size.height / 2 - 10;
        this.addChild(this.sprite_color_3, 5);
                                  
        this.sprite_color_4 = new cc.Sprite("res/stage2/banana.png");
        this.sprite_color_4.x = size.width / 2 + 90;
        this.sprite_color_4.y = size.height / 2 - 10;
        this.addChild(this.sprite_color_4, 6);
                                  
        this.sprite_color_5 = new cc.Sprite("res/stage2/orange.png");
        this.sprite_color_5.x = size.width / 2 + 10;
        this.sprite_color_5.y = size.height / 2 - 50;
        this.addChild(this.sprite_color_5, 7);
                                  
        this.sprite_color_6 = new cc.Sprite("res/stage2/pseudocerasus.png");
        this.sprite_color_6.x = size.width / 2 + 70;
        this.sprite_color_6.y = size.height / 2 - 80;
        this.addChild(this.sprite_color_6, 8);
                                  
        this.sprite_color_7 = new cc.Sprite("res/stage2/limon.png");
        this.sprite_color_7.x = size.width / 2 + 160;
        this.sprite_color_7.y = size.height / 2 - 80;
        this.addChild(this.sprite_color_7, 9);
                                  
        this.sprite_color_8 = new cc.Sprite("res/stage2/strawberry.png");
        this.sprite_color_8.x = size.width / 2 - 60;
        this.sprite_color_8.y = size.height / 2 - 100;
        this.addChild(this.sprite_color_8, 10);
                                  
        this.arry_pen = [new ColorSprite("res/stage2/pen_long_red.png", "red"),
                         new ColorSprite("res/stage2/pen_long_yellow.png", "yellow"),
                         new ColorSprite("res/stage2/pen_long_blue.png", "blue"),
                         new ColorSprite("res/stage2/pen_long_green.png", "green"),
                         new ColorSprite("res/stage2/pen_long_purple.png", "purple"),
                         new ColorSprite("res/stage2/pen_long_orange.png", "orange"),
                         new ColorSprite("res/stage2/pen_long_white.png", "white"),
                         new ColorSprite("res/stage2/pen_long_black.png", "black")];
        this.arry_pen[0].x = 60;
        this.arry_pen[0].y = size.height - 170 - gapY();
        this.addChild(this.arry_pen[0], 11);
                                  
        this.arry_pen[1].x = 60;
        this.arry_pen[1].y = size.height - 270 - gapY();
        this.addChild(this.arry_pen[1], 12);
                                  
        this.arry_pen[2].x = 60;
        this.arry_pen[2].y = size.height - 370 - gapY();
        this.addChild(this.arry_pen[2], 13);
                                  
        this.arry_pen[3].x = 60;
        this.arry_pen[3].y = size.height - 470 - gapY();
        this.addChild(this.arry_pen[3], 14);
                                  
        this.arry_pen[4].x = size.width - 60;
        this.arry_pen[4].y = size.height - 170 - gapY();
        this.addChild(this.arry_pen[4], 15);
                                  
        this.arry_pen[5].x = size.width - 60;
        this.arry_pen[5].y = size.height - 270 - gapY();
        this.addChild(this.arry_pen[5], 16);
                                  
        this.arry_pen[6].x = size.width - 60;
        this.arry_pen[6].y = size.height - 370 - gapY();
        this.addChild(this.arry_pen[6], 17);
                                  
        this.arry_pen[7].x = size.width - 60;
        this.arry_pen[7].y = size.height - 470 - gapY();
        this.addChild(this.arry_pen[7], 18);
                                      
        this.arry_color = [cc.color({r: 204, g: 0, b: 0, a: 255}),
                           cc.color({r: 255, g: 204, b: 0, a: 255}),
                           cc.color({r: 51, g: 102, b: 204, a: 255}),
                           cc.color({r: 51, g: 153, b: 51, a: 255}),
                           cc.color({r: 102, g: 51, b: 204, a: 255}),
                           cc.color({r: 255, g: 102, b: 0, a: 255}),
                           cc.color({r: 255, g: 255, b: 255, a: 200}),
                           cc.color({r: 0, g: 0, b: 0, a: 180})];
                                  
        var arry_menu_item = [];
        var closeItem = new cc.MenuItemImage(
            "res/RetBtnNormal.png",
            "res/ReturnBtnHigh.png",
            function () {
                this.removeAllChildren();
                ddStopAllEffect();
                cc.director.popToRootScene();
            }, this);
        closeItem.attr({
            x:isFullScreenDevice()?170:70,
            y: size.height - 65,
            anchorX: 0.5,
            anchorY: 0.5,
            scale:0.8
        });
        arry_menu_item[0] = closeItem;
                                    
        var menu_clear = new cc.MenuItemImage(
            "res/stage2/clear_normal.png",
            "res/stage2/clear_high.png",
            function(){
                cc.log("replay menu is clicked!");
                this.clearColor();
        }, this);
        menu_clear.attr({
            x: size.width - 90,
            y: size.height - 65,
            anchorX: 0.5,
            anchorY: 0.5
        });
        arry_menu_item[1] = menu_clear;
                                  
        var menu = new cc.Menu(arry_menu_item);
        menu.x = 0;
        menu.y = 0;
        this.addChild(menu, 19);
                                      
        var self = this;
        var sprite_listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                                                                                    
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                                                                                    
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
            //                target.setOpacity(255);
                cc.log("touch end");
                
                if (target == self.arry_pen[0]) {
                    self.n_color_select = 0;
                    self.showPenAnimation(self.arry_pen[0]);
                }else if (target == self.arry_pen[1]) {
                    self.n_color_select = 1;
                    self.showPenAnimation(self.arry_pen[1]);
                }else if (target == self.arry_pen[2]) {
                    self.n_color_select = 2;
                    self.showPenAnimation(self.arry_pen[2]);
                }else if (target == self.arry_pen[3]) {
                    self.n_color_select = 3;
                    self.showPenAnimation(self.arry_pen[3]);
                }else if (target == self.arry_pen[4]) {
                    self.n_color_select = 4;
                    self.showPenAnimation(self.arry_pen[4]);
                }else if (target == self.arry_pen[5]) {
                    self.n_color_select = 5;
                    self.showPenAnimation(self.arry_pen[5]);
                }else if (target == self.arry_pen[6]) {
                    self.n_color_select = 6;
                    self.showPenAnimation(self.arry_pen[6]);
                }else if (target == self.arry_pen[7]) {
                    self.n_color_select = 7;
                    self.showPenAnimation(self.arry_pen[7]);
                }else if(-1 != self.n_color_select){
                    if(self.isSpriteShouldDraw(self.sprite_color_8, touch, self.polygon_strawberry)){
                        self.sprite_color_8.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_7, touch, self.polygon_limon)){
                        self.sprite_color_7.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_6, touch, self.polygon_pseudocerasus)){
                        self.sprite_color_6.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_5, touch, self.polygon_orange)){
                        self.sprite_color_5.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_3, touch, self.polygon_grapes)){
                        self.sprite_color_3.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_4, touch, self.polygon_banana)){
                        self.sprite_color_4.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_1, touch, self.polygon_pear)){
                        self.sprite_color_1.setColor(self.arry_color[self.n_color_select]);
                    }else if(self.isSpriteShouldDraw(self.sprite_color_2, touch, self.polygon_apple)){
                        self.sprite_color_2.setColor(self.arry_color[self.n_color_select]);
                    }
                }
        }});
                                      
        cc.eventManager.addListener(sprite_listener, this.sprite_color_1);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_2);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_3);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_4);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_5);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_6);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_7);
        cc.eventManager.addListener(sprite_listener.clone(), this.sprite_color_8);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[0]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[1]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[2]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[3]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[4]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[5]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[6]);
        cc.eventManager.addListener(sprite_listener.clone(), this.arry_pen[7]);
                                  
        this.clearColor();
        
        this.showStarAd();
                                      
        return true;
    },
    
    showStarAd:function(){
    	showStarAd(this, this.star_ad, cc.p(cc.winSize.width - 80, -20));
    },
    
    clearColor:function(){
        this.sprite_color_1.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_2.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_3.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_4.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_5.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_6.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_7.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
        this.sprite_color_8.setColor(cc.color({r: 255, g: 255, b: 255, a: 255}));
    },
    showPenAnimation:function(sprite_pen){
        for(var index = 0; index < 8; ++index){
            this.arry_pen[index].stopAllActions();
        }
                                  
        var size = cc.winSize;
                                  
        this.arry_pen[0].x = 60;
        this.arry_pen[0].y = size.height - 170;
                                  
        this.arry_pen[1].x = 60;
        this.arry_pen[1].y = size.height - 270;
                                  
        this.arry_pen[2].x = 60;
        this.arry_pen[2].y = size.height - 370;
        
                                  
        this.arry_pen[3].x = 60;
        this.arry_pen[3].y = size.height - 470;
        
                                  
        this.arry_pen[4].x = size.width - 60;
        this.arry_pen[4].y = size.height - 170;
        
                                  
        this.arry_pen[5].x = size.width - 60;
        this.arry_pen[5].y = size.height - 270;
                                  
        this.arry_pen[6].x = size.width - 60;
        this.arry_pen[6].y = size.height - 370;
        
                                  
        this.arry_pen[7].x = size.width - 60;
        this.arry_pen[7].y = size.height - 470;
        
                                  
        
        var move_by_right_animation = new cc.MoveBy(0.5, cc.p(30, 0));
        var move_by_left_animation = new cc.MoveBy(0.5, cc.p(-30, 0));
                                  
        switch(sprite_pen.getColorName()){
            case "red":
            {
                this.arry_pen[0].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_right_animation, move_by_right_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Red.mp3");
                ddPlayEffect('',"res/sound/Red.mp3");
                break;
            }
            case "yellow":
            {
                this.arry_pen[1].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_right_animation, move_by_right_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Yellow.mp3");
                ddPlayEffect('',"res/sound/Yellow.mp3");
                break;
            }
            case "blue":
            {
                this.arry_pen[2].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_right_animation, move_by_right_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Blue.mp3");
                ddPlayEffect('',"res/sound/Blue.mp3");
                break;
            }
            case "green":
            {
                this.arry_pen[3].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_right_animation, move_by_right_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Green.mp3");
                ddPlayEffect('',"res/sound/Green.mp3");
                break;
            }
            case "purple":
            {
                this.arry_pen[4].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_left_animation, move_by_left_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Purple.mp3");
                ddPlayEffect('',"res/sound/Purple.mp3");
                break;
            }
            case "orange":
            {
                this.arry_pen[5].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_left_animation, move_by_left_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/Orange.mp3");
                ddPlayEffect('',"res/sound/Orange.mp3");
                break;
            }
            case "white":
            {
                this.arry_pen[6].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_left_animation, move_by_left_animation.reverse())));
                //cc.audioEngine.playEffect("res/sound/White.mp3");
                ddPlayEffect('',"res/sound/White.mp3");
                break;
            }
            case "black":
            {
                this.arry_pen[7].runAction(cc.RepeatForever.create(cc.Sequence.create(move_by_left_animation, move_by_left_animation.reverse())));
                ddPlayEffect('',"res/sound/Black.mp3");
                //cc.audioEngine.playEffect("res/sound/Black.mp3");
                break;
            }
        }
    },
    isPointInPolygon:function(point, arry_polygon){
        var x = point.x;
        var y = point.y;
        var b_inside = false;
        for(var i = 0, j = arry_polygon.length - 1; i < arry_polygon.length; j = i++){
            var xi = arry_polygon[i][0], yi = arry_polygon[i][1];
            var xj = arry_polygon[j][0], yj = arry_polygon[j][1];
                                  
            var intersect = ((yi > y) != (yj > y))
                            && (x < (xj - xi) * (y - yi) / (yj - yi) + xi);
            if (intersect){
                b_inside = !b_inside;
            }
        }
                                  
        return b_inside;
    },
    isSpriteShouldDraw:function(sprite_color, touch_point, arry_point){
        var point_in_polygon = sprite_color.convertTouchToNodeSpace(touch_point);
        if (cc.rectContainsPoint(sprite_color.getBoundingBox(), touch_point.getLocation()) && this.isPointInPolygon(point_in_polygon, arry_point)) {
            return true;
        }
                                  
        return false;
    },
    saveScreenShot:function(){
        var size = cc.winSize;
        var fileName = "DuoDuoColorGame.png";
        var texture = new cc.RenderTexture(size.width, size.height);
        texture.setPosition(size.width / 2, size.height / 2);
        texture.begin();
        cc.director.getRunningScene().visit();
        texture.end();
        texture.saveToFile(fileName, cc.IMAGE_FORMAT_PNG);
    }
});

var Stage2Scene = cc.Scene.extend({
    ctor:function(){
        this._super();
        var layer = new Stage2Layer();
        this.addChild(layer);
    },
    onEnter:function () {
        this._super();
    }
});

